<template>
  <div>
    <ObTable
      :items="list"
      :columns="columns"
      @select="$emit('on-select', $event)"
      class="additional-services-list"
    >
      <template v-slot:title="{data}">
        <NameOrder
          v-if="data.item.mainData"
          :item="data.item"
        />
        <SlotTitle
          v-else
          slot="title"
          slot-scope="{ data }"
          :service="data.item"
          :order="order"
        />
      </template>
      <SlotCorrectionDocument
        slot="correctionDocument"
        slot-scope="{ data }"
        :service="data.item"
        :order="order"
      />
      <template v-slot:includedInTariff="{ data }">
        <div style="padding-left: 15px;">
          <template v-if="data.item.isIncludedInTariff">
            <i style="font-size: 11px;" class="icon checked-simple -green-700" />
          </template>
          <template v-else>
            -
          </template>
        </div>
      </template>
      <template v-slot:createdAt="{ data }">
        <div class="d-f j-c-sb a-i-c">
          <div>
            <span>{{ data.item.createdAt | date('DD.MM.YYYY') }}</span>
            <span class="field-time">{{ data.item.createdAt | date('HH:mm') }}</span>
          </div>
          <FilesDropdown
            class="files-dropdown"
            :file-uuids="data.item.fileUuids || []"
          />
        </div>
      </template>

    </ObTable>
  </div>
</template>

<script>
  import ObTable from 'common-components/src/obComponents/obTable'
  import { formatNumber } from 'common-components/src/helpers/common'
  import NameOrder from './slots/nameOrder'
  import SlotTitle from './slots/tableTitle'
  import SlotCorrectionDocument from './slots/correctionDocument'
  import FilesDropdown from '@/components/Order/filesDropdown'

  export default {
    name: 'orderAdditionalServicesList',
    components: {
      ObTable,
      NameOrder,
      SlotTitle,
      SlotCorrectionDocument,
      FilesDropdown
    },
    props: {
      list: {
        type: Array,
        default: () => []
      },
      order: {
        type: Object,
        default: () => {}
      }
    },
    computed: {
      columns () {
        return [
          {
            title: 'наименование',
            key: 'title',
            slotName: 'title',
            width: 300
          },
          {
            title: 'номер',
            key: 'serviceNumber'
          },
          {
            title: 'создано',
            key: 'createdAt',
            slotName: 'createdAt'
          },
          {
            title: 'кол-во',
            key: 'count',
            html: (data) => data.count ? formatNumber(data.count) : '-'
          },
          {
            title: 'Единица измерения',
            key: 'serviceUnitTitle',
            html: (data) => data.serviceUnitTitle ? data.serviceUnitTitle : '-'
          },
          {
            headerHtml: () => `Суммир.<br>в одной<br>стр. счета`,
            key: 'isIncludedInTariff',
            exactWidth: '90px',
            slotName: 'includedInTariff'
          },
          {
            title: 'НДС, Р',
            key: 'vatValue',
            html: (data) => data.addServiceTotalAmount?.vatType !== 'NO_VAT' ? formatNumber(Math.abs(data.addServiceTotalAmount?.vatPrice / 100), { dot: 2 }) : '-'
          },
          {
            title: 'Итого без НДС, ₽',
            key: 'pricePerService',
            html: (data) => data.addServiceTotalAmount?.priceWithoutVat
              ? `<span class="${data.addServiceTotalAmount?.priceWithoutVat < 0 ? 'color-error' : ''}">${formatNumber(data.addServiceTotalAmount?.priceWithoutVat / 100, { dot: 2 })}</span>`
              : '-'
          },
          {
            title: 'Итого, ₽',
            key: 'pricePerService',
            slotName: 'correctionDocument',
            sortDisabled: true
          }
        ]
      }
    }
  }
</script>

<style lang="scss">
.field-time {
  margin-left: 8px;
  color: $color-grey-label;
}
.files-dropdown {
  margin-top: -2px;
  margin-left: 14px;
}

.additional-services-list {
  td:last-child {
    .td-container {
      justify-content: flex-end;
    }
  }
}

</style>
